unit BitBtnAnnule;
//http://perso.wanadoo.fr/bardou/michel/
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, iniFiles, comctrls, Spin;

type
  TBitBtnAnnule = class(TBitBtn)
  private
    FRecupActif: Boolean;
    FOnApresAnnule: TNotifyEvent;
    procedure SetRecupActif(const Value: Boolean);
    { Dclarations prives }
  protected
    FormAOwner:TForm;
    ListeDesValeursAConserver :TStringList;
    FormOldShow: TNotifyEvent;
    OldOnClick:TNotifyEvent;
    procedure MonOnClick (Sender: TObject);
    procedure loaded; override;
    procedure LaFormShow(sender: TObject);
  public
    Constructor Create(AOwner:TComponent); override;
    Destructor destroy ;override;
    procedure ExecuteLecture;
    procedure ExecuteEcriture;
  published
    property RecupActif : Boolean read FRecupActif write SetRecupActif;
    property OnApresAnnule : TNotifyEvent read FOnApresAnnule write FOnApresAnnule;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Perso', [TBitBtnAnnule]);
end;

{===========================================}
{renvoie la partie situe  droite de substr}
{===========================================}
function droite(substr: string; s: string): string;
begin
  if pos(substr,s)=0 then result:='' else
    result:=copy(s, pos(substr, s)+length(substr), length(s)-pos(substr, s)+length(substr));
end;

function StrToBool(Texte:String):Boolean;
// transforme un String en Boolean
begin
   if Uppercase(Texte)='TRUE' then Result:=true else Result:=false;
end;

function BoolToStr(Bool:Boolean):String;
// transforme un Boolean en DString
begin
   if Bool then Result:='true' else Result:='false';
end;


procedure TBitBtnAnnule.ExecuteLecture;
var
    j,Index:integer;

begin
  For j:=0 to FormAOwner.ComponentCount-1 do //pour chaque composant de la fiche
  begin
  try
    if FormAOwner.Components[j] is TEdit then
    begin
     Index:=ListeDesValeursAConserver.IndexOfName('TEdit '+FormAOwner.Components[j].Name);
     TEdit(FormAOwner.Components[j]).Text:=droite('=',ListeDesValeursAConserver.Strings[Index]);
    end;
    if FormAOwner.Components[j] is TDateTimePicker then
    begin
      Index:=ListeDesValeursAConserver.IndexOfName('TDateTimePicker '+FormAOwner.Components[j].Name);
      TDateTimePicker(FormAOwner.Components[j]).DateTime:=StrToDateTime(droite('=',ListeDesValeursAConserver.Strings[Index]));
    end;
    if FormAOwner.Components[j] is TCheckBox then
    begin
      Index:=ListeDesValeursAConserver.IndexOfName('TCheckBox '+FormAOwner.Components[j].Name);
      TCheckBox(FormAOwner.Components[j]).Checked:=StrToBool(droite('=',ListeDesValeursAConserver.Strings[Index]));
    end;
    if FormAOwner.Components[j] is TRadioButton then
    begin
      Index:=ListeDesValeursAConserver.IndexOfName('TRadioButton '+FormAOwner.Components[j].Name);
      TRadioButton(FormAOwner.Components[j]).Checked:=StrToBool(droite('=',ListeDesValeursAConserver.Strings[Index]));
    end;
    if FormAOwner.Components[j] is TSpinEdit then
    begin
      Index:=ListeDesValeursAConserver.IndexOfName('TSpinEdit '+FormAOwner.Components[j].Name);
      TSpinEdit(FormAOwner.Components[j]).Value:=StrToInt(droite('=',ListeDesValeursAConserver.Strings[Index]));
    end;
  except end;
  end; //fin for composant de la fiche
  if Assigned(FOnApresAnnule) then FOnApresAnnule(Self);
end;


procedure TBitBtnAnnule.ExecuteEcriture;
var
    j:integer;
    Fiche:TForm;
begin
  ListeDesValeursAConserver.Clear;
  Fiche:=FormAOwner;
  For j:=0 to Fiche.ComponentCount-1 do //pour chaque composant de la fiche
  begin
  try
    if Fiche.Components[j] is TEdit then
    begin
      ListeDesValeursAConserver.Add('TEdit '+Fiche.Components[j].Name
      +'='+Tedit(Fiche.Components[j]).Text);
    end;
    if Fiche.Components[j] is TDateTimePicker then
    begin
      ListeDesValeursAConserver.Add('TDateTimePicker '+Fiche.Components[j].Name
      +'='+DateTimeToStr(TDateTimePicker(Fiche.Components[j]).DateTime));
    end;
    if Fiche.Components[j] is TCheckBox then
    begin
      ListeDesValeursAConserver.Add('TCheckBox '+ Fiche.Components[j].Name
      +'='+BoolToStr(TCheckBox(Fiche.Components[j]).Checked));
    end;
    if Fiche.Components[j] is TRadioButton then
    begin
      ListeDesValeursAConserver.Add('TRadioButton '+ Fiche.Components[j].Name
      +'='+BoolToStr(TRadioButton(Fiche.Components[j]).Checked));
    end;
    if Fiche.Components[j] is TSpinEdit then
    begin
      ListeDesValeursAConserver.Add('TSpinEdit '+ Fiche.Components[j].Name
      +'='+IntToStr(TSpinEdit(Fiche.Components[j]).Value));
    end;
  except end;  
  end; //fin for composant de la fiche
end;


{ TBitBtnAnnule }

constructor TBitBtnAnnule.Create(AOwner: TComponent);
begin
  inherited;
  FOnApresAnnule:=nil;
  if csDesigning in ComponentState then
  begin
    Kind:=bkAbort;
    RecupActif:=true;
  end;
  if not (csDesigning in ComponentState) then //si on est pas en mode conception
  begin
      FormAOwner:=TForm(AOwner);// la forme propritaire de notre composant
      FormOldShow:=FormAOwner.OnShow; // sauvegarde de l'vnement OnShow dans FormOldShow
      FormAOwner.OnShow:=LaFormShow; // on redirige l'vnement OnShow vers LaFormShow
      ListeDesValeursAConserver:=TStringList.create;
  end;
end;


destructor TBitBtnAnnule.destroy;
begin
  ListeDesValeursAConserver.free;
  inherited;
end;

procedure TBitBtnAnnule.LaFormShow(sender: TObject);
begin
  If assigned(FormOldShow) then FormOldShow(sender);
  ExecuteEcriture;
end;

procedure TBitBtnAnnule.loaded;
begin
  inherited;
  if not (csDesigning in ComponentState) then //si on est pas en mode conception
  begin
    OldOnClick:=OnClick;
    inherited OnClick:=MonOnClick;
  end;
end;

procedure TBitBtnAnnule.MonOnClick(Sender: TObject);
begin
  if Assigned(OldOnClick) then OldOnClick(Sender);
  if RecupActif then ExecuteLecture;
end;


procedure TBitBtnAnnule.SetRecupActif(const Value: Boolean);
begin
  FRecupActif := Value;
end;

end.
